#include <stdio.h>
#include <stdlib.h>
#include <qregexp.h>
#include <qstring.h>
#include <qstylesheet.h>

unsigned char ipa2lingvo[] = {
  0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
  0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f,
  0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17,
  0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f,
  0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27,
  0x28, 0x29, 0x2a, 0x3a, 0x2c, 0x2d, 0x2e, 0x2f,
  0x30, 0x31, 0x32, 0x2c, 0x34, 0x35, 0x36, 0x37,
  0x38, 0x39, 0x3a, 0x3b, 0x3c, 0x3d, 0x3e, 0x3f,
  0x40, 0x41, 0x42, 0x43, 0xb9, 0x27, 0xb5, 0x47,
  0x48, 0x69, 0x4a, 0x4b, 0x4c, 0x4d, 0xbc, 0x4f,
  0x50, 0xb7, 0x52, 0xbf, 0xbe, 0x55, 0x56, 0x57,
  0x58, 0x59, 0xb6, 0x5b, 0x5c, 0x5d, 0x5e, 0x5f,
  0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67,
  0x68, 0x69, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f,
  0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77,
  0x78, 0x79, 0x7a, 0x7b, 0x7c, 0x7d, 0x7e, 0x7f,
  0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
  0xb8, 0x89, 0x8a, 0x8b, 0x8c, 0x8d, 0x8e, 0x8f,
  0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97,
  0x98, 0x99, 0x9a, 0x9b, 0x9c, 0x9d, 0x9e, 0x9f,
  0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7,
  0xa8, 0xa9, 0xaa, 0xab, 0xac, 0xad, 0xae, 0xaf,
  0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7,
  0xb8, 0xb9, 0xba, 0xbb, 0xbc, 0xbd, 0xbe, 0xbf,
  0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7,
  0xc8, 0xc9, 0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
  0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7,
  0xd8, 0xd9, 0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,
  0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7,
  0xe8, 0xe9, 0xea, 0xeb, 0xec, 0xed, 0xee, 0xef,
  0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7,
  0xf8, 0xf9, 0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff
};

QString translate_transcriptions( QString s ) {
  QString trans, result, res2;
  int i, pos = 0;

  QRegExp rx( "\\[([^]]+)\\]" );
  for (;;) {
	pos = rx.search( s, pos );
	if ( pos == -1 ) break;
	trans = rx.cap(1);
	result = QString::null;
	res2 = QString::null;
	for ( i = 0; i < trans.length(); i++ ) {
		if ( i ) {
			result += ' ';
			res2 += ' ';
		}
		result += QString::number( ipa2lingvo[trans[i].unicode() & 0xff] );
		res2 += QString::number( ipa2lingvo[trans[i].unicode() & 0xff], 16 );
	}
	result = "<t disposition=\"inline\">" + result + "</t>\n<!-- " +
		res2 + " -->\n";
	s.replace( pos, rx.cap().length(), result );
	pos += trans.length();;
  }

  return s;
}

QString do_mark_sections( QString s ) {
  int pos, mpos, pos1, pos2, pos3;
  QRegExp r1("_([IVX]+)"), r2("(\\d+\\.)"), r3("(\\d+)&gt;"), *rx;
  QString startTag("<m1>"), stopTag("</m1>"), newStartTag, newStopTag,
  	markText, replText;

  s = startTag + s;
  pos = startTag.length();
  for (;;) {
  	mpos = s.length();
	markText = QString::null;
  	pos1 = r1.search( s, pos );
	if ( pos1 != -1 && pos1 < mpos ) {
		mpos = pos1;
		newStartTag = "<m1>";
		newStopTag = "</m1>";
		rx = &r1;
	}
	pos2 = r2.search( s, pos );
	if ( pos2 != -1 && pos2 < mpos ) {
		mpos = pos2;
		newStartTag = "<m2>";
		newStopTag = "</m2>";
		rx = &r2;
	}
	pos3 = r3.search( s, pos );
	if ( pos3 != -1 && pos3 < mpos ) {
		mpos = pos3;
		newStartTag = "<m3>";
		newStopTag = "</m3>";
		rx = &r3;
		markText = rx->cap(1) + ")";
	}
	if ( mpos == s.length() ) break;
	if ( !markText ) markText = rx->cap(1);
	replText = stopTag + newStartTag + markText;
	s.replace( mpos, rx->cap().length(), replText );
	pos = mpos + replText.length();
	startTag = newStartTag;
	stopTag = newStopTag;
  }
  s = s + stopTag;

  return s;
}

QString mark_comments( QString s ) {
  QString com;
  int pos = 0;

  QRegExp rx( "_(\\S*)" );
  for (;;) {
	pos = rx.search( s, pos );
	if ( pos == -1 ) break;
	com = rx.cap(1);
	s.replace( pos, com.length() + 1, "<com>" + com + "</com>" );
  }

  return s;
}

int main( int argc, char **argv ) {
  FILE *fdwa, *fxml;
  char *buf, *p, *s;
  int art_len, rc;
  QString ws;

  putenv( "LANG=ru_RU.KOI8-R" );

  if ( argc < 3 ) {
  	puts( "Syntax: ./muller2xml <muller7.dwa> <muller7.xml>" );
	return 1;
  }

  fdwa = fopen( argv[1], "r" );
  if ( !fdwa ) {
  	perror( "fdwa open" );
	return 1;
  }
  fxml = fopen( argv[2], "w" );
  if ( !fxml ) {
  	perror( "fxml open" );
	return 1;
  }

  buf = (char*) malloc( 32768 );

  fputs( "<dictionary>\n", fxml );
  while ( !feof(fdwa) ) {
  	s = fgets( buf, 32768-1, fdwa );
	if ( (int)s == EOF ) break;
	art_len = strlen( buf );
	buf[art_len] = 0;

	p = strstr( buf, "  " );
	if ( !p ) continue;

	fputs( "<entry word=\"", fxml );
	ws = QString::fromLocal8Bit( buf, p - buf );
	ws = QStyleSheet::escape( ws );
	s = strdup(ws.utf8().data());
	fwrite( s, 1, strlen(s), fxml );
	free( s );
	fputs( "\">\n", fxml );

//	fputs( "<m1>", fxml );
	ws = QString::fromLocal8Bit( p + 2 );
	ws = QStyleSheet::escape( ws );
//	ws = mark_transcriptions( ws );
	ws = translate_transcriptions( ws );
//	ws = mark_sections1( ws );
	ws = do_mark_sections( ws );
	ws = mark_comments( ws );
	s = strdup(ws.utf8().data());
	fwrite( s, 1, strlen(s), fxml );
	free( s );
//	fputs( "</m1>", fxml );

	fputs( "</entry>\n", fxml );
  }
  fputs( "</dictionary>\n", fxml );

  return 0;
}
